const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const bills = sequelize.define(
    'bills',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

bill_no: {
        type: DataTypes.TEXT,
      
      

      },

bill_date: {
        type: DataTypes.DATE,
      
      

      },

due_date: {
        type: DataTypes.DATE,
      
      

      },

gross_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

amount_paid: {
        type: DataTypes.DECIMAL,
      
      

      },

balance_due: {
        type: DataTypes.DECIMAL,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"approved",


"posted",


"partially_paid",


"paid",


"voided",


"overdue"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  bills.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



















    db.bills.hasMany(db.bill_lines, {
      as: 'bill_lines_bill',
      foreignKey: {
          name: 'billId',
      },
      constraints: false,
    });


    db.bills.hasMany(db.bill_payments, {
      as: 'bill_payments_bill',
      foreignKey: {
          name: 'billId',
      },
      constraints: false,
    });


    db.bills.hasMany(db.ledger_entries, {
      as: 'ledger_entries_bill',
      foreignKey: {
          name: 'billId',
      },
      constraints: false,
    });







//end loop



    db.bills.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });

    db.bills.belongsTo(db.vendors, {
      as: 'vendor',
      foreignKey: {
        name: 'vendorId',
      },
      constraints: false,
    });

    db.bills.belongsTo(db.vehicles, {
      as: 'vehicle',
      foreignKey: {
        name: 'vehicleId',
      },
      constraints: false,
    });




    db.bills.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.bills.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return bills;
};


